// MyTestAutoEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MyTestAutoEdit.h"
#include "MyTestAutoEditDlg.h"
#include "Kod.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString CAdrValidate::validate(CString &str)
{
 char *end_ptr;
 int j;

  j = strtol(str,&end_ptr,16);
  if (*end_ptr) 
 	 return("   0-9   a-f(A_F)!");
  else 
     if(j>0x1f)
	    return("     0  1f  !!!");
     else
	    return(_T(""));
}


CString CCanValidate::validate(CString &str)
{
 char *end_ptr;
 int j;

  j = strtol(str,&end_ptr,10);
  if (*end_ptr) 
 	 return("   0123!");
  else 
     return(_T(""));
}
/////////////////////////////////////////////////////////////////////////////
// CMyTestAutoEditDlg dialog

CMyTestAutoEditDlg::CMyTestAutoEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMyTestAutoEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMyTestAutoEditDlg)
	m_adrVal = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMyTestAutoEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyTestAutoEditDlg)
	DDX_Control(pDX, IDC_EDITcan2, m_can2);
	DDX_Control(pDX, IDC_EDITcan1, m_can1);
	DDX_Control(pDX, IDC_EDITadr, m_adr);
	DDX_Text(pDX, IDC_EDITadr, m_adrVal);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMyTestAutoEditDlg, CDialog)
	//{{AFX_MSG_MAP(CMyTestAutoEditDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyTestAutoEditDlg message handlers

BOOL CMyTestAutoEditDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
/// Create!!!
	CRect rc;
	CKod CK;
    GetDlgItem(IDC_kod1)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	CK.CreateKod(this, rc,100);	
    GetDlgItem(IDC_kod2)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	CK.CreateKod(this, rc,200);	

////

	m_adr.SetMaxChars(2);
	m_adr.SetValidChar(_T("0123456789abcdef"));
	m_AdrValidate = new CAdrValidate;
	m_adr.SetValidationHandler(m_AdrValidate);
	m_adr.SetDefaultValue(_T("0"));
	m_adr.SetText();

	m_can1.SetMaxChars(1);
	m_can1.SetValidChar(_T("0123"));
	m_can1Validate = new CCanValidate;
	m_can1.SetValidationHandler(m_can1Validate);
	m_can1.SetDefaultValue(_T("0"));
	m_can1.SetText();

	m_can2.SetMaxChars(1);
	m_can2.SetValidChar(_T("0123"));
	m_can1Validate = new CCanValidate;
	m_can2.SetValidationHandler(m_can1Validate);
	m_can2.SetDefaultValue(_T("1"));
	m_can2.SetText();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMyTestAutoEditDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMyTestAutoEditDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//void CMyTestAutoEditDlg::OnOK() 
//{
	
//	MessageBox("kuku","OnOK",MB_OK);
//}





BOOL CMyTestAutoEditDlg::PreTranslateMessage(MSG* pMsg) 
{
if(pMsg->message == WM_KEYDOWN)
{
	if(pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
	{
		::TranslateMessage(pMsg);
		::DispatchMessage(pMsg);
		return TRUE;
	}
}
	return CDialog::PreTranslateMessage(pMsg);
}

void CMyTestAutoEditDlg::OnButton1() 
{
	UpdateData(true);
	EndDialog(0);	
}
